﻿using JudgeModule;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Controller : MonoBehaviour
{
    public Note Instance { get; set; }

    public List<Controller> enables,
                            disables;

    private readonly float minAlpha = 0.3f;
    private readonly float maxAlpha = 0.7f;
    
    public void Deactivate(Transform deactives, bool isCorrectlyFinish = true)
    {
        Instance.Activated = false;

        foreach (Image img in GetComponentsInChildren<Image>())
        {
            Color tmp = img.color;
            tmp.a = 0f;
            img.color = tmp + new Color(0, 0, 0, minAlpha);
        }

        transform.SetParent(deactives);
        disables.Add(enables[0]);
        enables.RemoveAt(0);

        AllSceneManager.JudgeCount[Judge.MISS] += 
            (Instance.TotalCount - Instance.JudgeCount);
        if (Instance.IsLong && !isCorrectlyFinish)
            ++AllSceneManager.JudgeCount[Judge.MISS];

        //Debug.Log("Deactivate: " + AllSceneManager.TotalJudge);
    }

    public float EndPosition(float ScrollSpeed)
    {
        return transform.position.x +
            (Instance.EndTiming - Instance.StartTiming) * ScrollSpeed;
    }

    public float StartPosition()
    {
        return transform.position.x;
    }
}