﻿using TrackAnalysis;
using UnityEngine;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour {
    private static GameManager instance;
    public static GameManager Instance
    {
        get
        {
            if (instance == null)
            {
                instance = FindObjectOfType(typeof(GameManager))
                    as GameManager;
                if (instance == null)
                    instance = new GameObject().AddComponent<GameManager>();

                instance.CurrentTrack
                    = new TrackInfo("Assets/Tracks/Tutorial/temp2.bpe");
            }

            return instance;
        }
    }

    [SerializeField]
    public string defaultSound;
    
    public TrackInfo CurrentTrack { get; set; }

    // Use this for initialization
    void Start()
    {
        DontDestroyOnLoad(Instance);
    }

    public void SceneTransition(string sceneName, bool additive = false)
    {
        SceneManager.LoadScene("Scene/" + sceneName,
            additive ? LoadSceneMode.Additive : LoadSceneMode.Single);
    }
}
