﻿using UnityEngine;
using UnityEngine.UI;

public class JudgeTextManager : MonoBehaviour
{
    private float start;
    private Text text;

    private NoteType type;
    private float startTiming, endTiming;

    private void Start()
    {
        text = gameObject.GetComponent<Text>();
    }

    private void OnEnable()
    {
        start = Time.time;
    }

    // Update is called once per frame
    private void Update ()
    {
        if (Time.time - start > 0.5)
            gameObject.SetActive(false);
    }

    public void Register(Note note)
    {
        type        = note.Type;
        startTiming = note.StartTiming;
        endTiming   = note.EndTiming;
    }

    public bool IsRegistered(Note note)
    {
        return type        == note.Type        &&
               startTiming == note.StartTiming &&
               endTiming   == note.EndTiming;
    }

    public void UnRegister()
    {
        type = NoteType.BeatLine;
    }
}
