﻿public class Note
{
    public Controller Component = null;

    public int JudgeCount;
    public int TotalCount;

    public float StartTiming { get; private set; }
    public float EndTiming { get; private set; }
    public NoteType Type { get; private set; }
    public string Key { get; private set; }

    public bool Activated { get; set; }

    public bool IsLong
    {
        get
        {
            return Length != 0f;
        }
    }

    public float Length
    {
        get
        {
            return EndTiming - StartTiming;
        }
    }

    public Note(float start, float end)
    {
        StartTiming = start;

        if (end == 0f)
            EndTiming = start;
        else
            EndTiming = end;
    }

    public Note(NoteType type, float start, float end = 0f)
    : this(start, end)
    {
        Type = type;
    }

    public Note(string type, float start, float end = 0f)
    : this(start, end)
    {
        switch (type)
        {
            case "SBT":
                Type = NoteType.SBT;
                break;
            case "LBT":
                Type = NoteType.LBT;
                break;
            case "SMO":
                Type = NoteType.SMO;
                break;
            case "LMO":
                Type = NoteType.LMO;
                break;
            default:
                break;
        }
    }

    public Note(string key, string type, float start, float end = 0f)
    : this(type, start, end)
    {
        Key = key;
    }
}